<?php
// call required includes
require_once('config.php');
require_once('lib/common.lib.php');

echo "<p>Requesting data from $market_api_url ...</p>\n";

// use cURL to request json string from API
$json_result = bitsci::curl_simple_post($market_api_url, false);

if (!empty($json_result)) {

  // check json data result
  $json_array = json_decode($json_result, true);
  
  if (!empty($json_array) && ($json_array !== null)) {

    // open local file for writing
    $fp = fopen($json_file, "w");
  
    // write to our opened file.
    if (fwrite($fp, $json_result) === FALSE) { 
      echo "<p>FAILURE! Could not write data to local file!</p>\n";
	  exit;
    } else {
      echo "<p>SUCCESS! $json_file has been updated!</p>\n";
    }
  
    // release file handle
    fclose($fp);
  
  } else {
    die("<p>FAILURE! API returned an error!</p>");
  }
} else {
  die("<p>FAILURE! API is not responding!</p>");
}

if ($save_to_db) {
	
  // connect to database
  $conn = connect_to_db($settings['db_server'],
						$settings['db_username'],
						$settings['db_password'], 
						$settings['db_database']);
						
  // search for user-specified data set
  foreach ($json_array as $keys => $market_data) {
    if ($market_data['symbol'] == strtolower($currency_market).strtoupper($curr_name)) {
      $btc_stats = $market_data;
	  $found_data = true;
    }
  }

  // create individual variables safe for a db query
  $high = safe_sql_str($btc_stats['high']);
  $low = safe_sql_str($btc_stats['low']);
  $vol = safe_sql_str($btc_stats['volume']);
  $avg = safe_sql_str($btc_stats['avg']);
  $buy = safe_sql_str($btc_stats['bid']);
  $sell = safe_sql_str($btc_stats['ask']);
  $last = safe_sql_str($btc_stats['close']);
  
  // attempt to insert the ticker data into the database
  if (update_btc($high, $low, $vol, $avg, $buy, $sell, $last)) {
    echo "<p>SUCCESS! Market data was successfully inserted into database.</p>\n"; 
  } else {
    echo "<p>FAILURE! There was a problem inserting the data into the db.</p>\n"; 
  }
}
?>