<?php

/*
START CRITICAL/CONNECTION DB FUNCTIONS
*/

function graceful_crash($error_code, $sql_str) { 
  $error_msg = "<h1>We have a problem...the system has encountered a fatal error.</h1>";
}

function connect_to_db($dbh, $dbu, $dbp, $dbn, $dbt) {
  if (isset($GLOBALS['conn'])) {
    return $GLOBALS['conn'];
  } else {
    $mysqli = new mysqli($dbh, $dbu, $dbp, $dbn, $dbt);
    if ($mysqli->connect_errno) {
      graceful_crash('None', $mysqli);
    } else {
	  return $mysqli;
	}
  }
}

function mysqli_result($res, $row, $field=0) { 
  $res->data_seek($row); 
  $datarow = $res->fetch_array(); 
  return $datarow[$field]; 
}

function clean_input_vars($vars) {
  $result = array();
  foreach ($vars as $key => $value) {
    $result[$key] = safe_sql_str($value);
  }
  return $result;
}

/*
START GENERAL/GLOBAL DB FUNCTIONS
*/

function select_from($table, $sel_str, $rules='') {
  global $conn;
  $sql_str = "
  SELECT $sel_str
  FROM $table
  $rules";
  $sql_result = $conn->query($sql_str);
  if ($sql_result) {
    if ($sql_result->num_rows <= 0) {
      return 'N/A';
    } else {
      return $sql_result;
    }
  } else {
	graceful_crash($sql_str);
  }
}

function select_from_where($table, $sel_str, $where, $rules='') {
  global $conn;
  $sql_str = "
  SELECT $sel_str
  FROM $table
  WHERE $where
  $rules";
  $sql_result = $conn->query($sql_str);
  if ($sql_result) {
    if ($sql_result->num_rows <= 0) {
      return 'N/A';
    } else {
      return $sql_result;
    }
  } else {
	graceful_crash($sql_str);
  }
}

function insert_into($table, $ins_str, $values) {
  global $conn;
  $sql_str = "
  INSERT INTO $table (".$ins_str.")
  VALUES (".$values.")";
  $sql_result = $conn->query($sql_str);
  if ($sql_result) {
    return $sql_result->insert_id();
  } else {
	graceful_crash($sql_str);
  }
}

function insert_into_where($table, $ins_str, $values, $where) {
  global $conn;
  $sql_str = "
  INSERT INTO $table (".$ins_str.")
  VALUES (".$values.")
  WHERE $where";
  $sql_result = $conn->query($sql_str);
  if ($sql_result) {
    return $sql_result->insert_id();
  } else {
	graceful_crash($sql_str);
  }
}

function update_where($table, $set_str, $value, $where) {
  global $conn;
  $sql_str = "
  UPDATE $table 
  SET $set_str = $value 
  WHERE $where";
  $sql_result = $conn->query($sql_str);
  if ($sql_result) {		
    return $sql_result;
  } else {
	graceful_crash($sql_str);
  }
}

function multi_update($table, $set_str, $where) {
  global $conn;
  $sql_str = "
  UPDATE $table 
  SET $set_str 
  WHERE $where";
  $sql_result = $conn->query($sql_str);
  if ($sql_result) {		
    return $sql_result;
  } else {
	graceful_crash($sql_str);
  }
}

function delete_from($table, $where) {
  global $conn;
  $sql_str = "
  DELETE FROM $table 
  WHERE $where";
  $sql_result = $conn->query($sql_str);
  if ($sql_result) {		
    return $sql_result;
  } else {
	graceful_crash($sql_str);
  }
}

function mysql_now() {
  global $conn;
  $sql_str = "SELECT NOW()";
  $sql_result = $conn->query($sql_str);
  if ($sql_result) {
    if ($sql_result->num_rows <= 0) {
      return 'N/A';
    } else {
      return mysqli_result($sql_result, 0);
    }
  } else {
	graceful_crash($sql_str);
  }
}

/*
-------------
*/

function update_btc($high, $low, $vol, $avg, $buy, $sell, $last) {
  return insert_into('BTC', 'high, low, vol, avg, buy, sell, last',
					 "$high, $low, $vol, $avg, $buy, $sell, $last");
}

?>